/* FILE: minevolver.h                 -*-Mode: c++-*-
 *
 * Abstract minimization evolver class
 *
 */

#ifndef _OXS_MINEVOLVER
#define _OXS_MINEVOLVER

#include "evolver.h"

/* End includes */

class Oxs_MinDriver; // Forward reference

class Oxs_MinEvolver:public Oxs_Evolver {
protected:
  Oxs_MinEvolver(const char* name,     // Child instance id
                 Oxs_Director* newdtr)  // App director
    : Oxs_Evolver(name,newdtr) {}
  Oxs_MinEvolver(const char* name,
                 Oxs_Director* newdtr,
                 const char* argstr)      // MIF block argument string
    : Oxs_Evolver(name,newdtr,argstr) {}
public:
  virtual ~Oxs_MinEvolver() {}

  virtual  BOOL
  Step(const Oxs_MinDriver* driver,
       Oxs_ConstKey<Oxs_SimState> current_state,
       Oxs_Key<Oxs_SimState>& next_state) = 0;
  // Returns true if step was successful, false if
  // unable to step as requested.

};

#endif // _OXS_MINEVOLVER
